9.LeetCode算法习题讲解--滑动窗口--无重复字符的最长字串

一.题目

习题链接:3. 无重复字符的最长子串 - 力扣(LeetCode)

二.题目讲解

关键词:子串(连续!)≠子序列(可以不连续)

给定字符串 s,找到连续 的、不含重复字符的最长一段,返回它的长度。 示例 "pwkew":

  • pwke 不是答案,因为字符不连续(子序列);
  • wke 是连续子串,长度 3,为正确答案。

三.算法原理讲解

解法一:暴力枚举 + 哈希表

算法流程演示,例子:s = "abcabcbb"

  • i = 0(起点 a) j=0 (a) → 无重复;j=1 (b) → 无重复;j=2 (c) → 无重复;j=3 (a) → a 重复,停止。长度 = 3
  • i = 1(起点 b) j=1 (b);j=2 (c);j=3 (a);j=4 (b) 重复,长度 = 3
  • i = 2(起点 c) j=2 (c);j=3 (a);j=4 (b);j=5 (c) 重复,长度 = 3 ...... 不断遍历所有起点,最终最大长度为 3

解法二:滑动窗口 + 哈希表

由上面的过程我们启发到,当right找到哈希表中的相同元素后,如果让它回到 left 继续重复次相同的步骤就很低效,因为哈希表中的相同元素没有被剔除;

如果相同元素在第一个位置,left++一次就剔除了,但是若相同元素在right的前一位,需要很多重复步骤。

所以我们可以让right找到相同元素后不动,让left++,直到把相同元素给剔除之后,再让right++

注意:这里更新长度放在插入之后,就更新一下

四.编写代码

代码一:哈希数组进行映射

定义一个哈希数组,然后遍历字符串,将字符串自动转化为整数,存放在数组中,相同字符转化为同意数字,然后存放在相同位置,就会大于1,然后就让left++,直到把相同元素剔除,再让right++

代码二:哈希表

cpp 复制代码
class Solution {
public:
    int lengthOfLongestSubstring(string s) {
        unordered_set<char> st;
        int left = 0, right = 0, len = 0;
        for(;right < s.size();right++)
        {
            
            while(st.find(s[right]) != st.end())
            {
                st.erase(s[left++]);
            }
            st.insert(s[right]);
            len = max(len ,right - left + 1);     
        }
        return len;

    }
};
相关推荐
lll2352691779几秒前
HR如何快速整理面试沟通内容?
面试·职场和发展
零售校长23 分钟前
西湖区零售门店店长面试怎么准备
面试·职场和发展·零售
秋天的怀念_David25 分钟前
算法一千零一夜 · 第十四夜 幻方与奇妙的二进制
java·程序人生·算法
薛定e的猫咪31 分钟前
(ICLR 2020)MAML 靠的不是快速学习,而是特征复用
人工智能·深度学习·学习·算法·机器学习
薛定e的猫咪1 小时前
(ICLR 2026)DF-META:面向 FJSP 的无导数元学习实例自适应调度
人工智能·深度学习·学习·算法·机器学习
java_nnnn2 小时前
LeetCode刷题滑动窗口(水果成篮+找到字符串中所有字母的异位词)Java
java·开发语言·leetcode
小羊没烦恼!2 小时前
异步编程:线程概述及使用
java·开发语言·mysql·算法·c#
wanderist.3 小时前
202609CSP认证P3
算法
云淡风轻~窗明几净3 小时前
角谷猜想最接近严格证明的测试 Version1.1.1
人工智能·算法·机器学习·图论
机器学习之心3 小时前
PINN × SVM × NSGA-II × 熵权TOPSIS:一套跑通「建模—优化—决策」的多目标优化框架
算法·机器学习·支持向量机